/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2013 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.genomeview.gui.menu.navigation;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;
import javax.swing.KeyStroke;

import net.sf.genomeview.data.Model;
import net.sf.genomeview.gui.external.ExternalHelper;
import net.sf.genomeview.gui.menu.AbstractModelAction;


public class GotoPosition extends AbstractModelAction {

    private static final long serialVersionUID = 3533852596396875672L;

    public GotoPosition(Model model) {
        super("Goto position", model);
        super.putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke("control G"));
    }

    @Override
    public void actionPerformed(ActionEvent arg0) {
        String input = JOptionPane.showInputDialog("Provide a coordinate");
        if (input != null&&input.trim().length()>0) {
        	try{
        		int i = Integer.parseInt(input.trim());
        		super.model.vlm.center(i);
            }catch(NumberFormatException e){
            	ExternalHelper.setPosition(input.trim(), model);
            }
            
        }

    }

}
